Index: /palm/trunk/SOURCE/parin.f90
===================================================================
--- /palm/trunk/SOURCE/parin.f90	(revision 4841)
+++ /palm/trunk/SOURCE/parin.f90	(revision 4842)
@@ -730,74 +480,40 @@
 !
 !-- Read the control parameters for initialization.
-!-- The namelist "inipar" must be provided in the NAMELIST-file.
-    READ ( 11, initialization_parameters, ERR=10, END=11 )
-    GOTO 14
-
- 10 BACKSPACE( 11 )
-    READ( 11 , '(A)') line
-    CALL parin_fail_message( 'initialization_parameters', line )
-
- 11 REWIND ( 11 )
-    READ( 11, inipar, ERR=12, END=13 )
-
-    message_string = 'namelist inipar is deprecated and will be ' //                               &
-                     'removed in near future. & Please use namelist ' //                           &
-                     'initialization_parameters instead'
-    CALL message( 'parin', 'PA0017', 0, 1, 0, 6, 0 )
-
-    GOTO 14
-
- 12 BACKSPACE( 11 )
-    READ( 11 , '(A)') line
-    CALL parin_fail_message( 'inipar', line )
-
- 13 message_string = 'no initialization_parameters-namelist found'
-    CALL message( 'parin', 'PA0272', 1, 2, 0, 6, 0 )
-
+!-- The namelist "initialisation_parameters" must be provided in the NAMELIST-file.
+    READ( 11, initialization_parameters, IOSTAT=io_status )
+
+!
+!-- Action depending on the READ status
+    IF ( io_status > 0 )  THEN
+!
+!--    initialisation_parameters namelist was found but countained errors. Print an error message
+!-     including the line that caused the problem.
+       BACKSPACE( 11 )
+       READ( 11 , '(A)' ) line
+       CALL parin_fail_message( 'initialization_parameters', line )
+
+    ELSEIF ( io_status < 0 )  THEN
+!
+!--    initialisation_parametes namelist was not found. Return a message.
+       message_string = 'no initialization_parameters-namelist found'
+       CALL message( 'parin', 'PA0272', 1, 2, 0, 6, 0 )
+
+    ENDIF
 !
 !-- Try to read runtime parameters given by the user for this run (namelist "runtime_parameters").
 !-- The namelist "runtime_parmeters" can be omitted. In that case default values are used for the
 !-- parameters.
- 14 line = ' '
-
     REWIND( 11 )
-    line = ' '
-    DO WHILE ( INDEX( line, '&runtime_parameters' ) == 0 )
-       READ( 11, '(A)', END=16 )  line
-    ENDDO
-    BACKSPACE( 11 )
-
-!
-!-- Read namelist
-    READ( 11, runtime_parameters, ERR = 15 )
-    GOTO 18
-
- 15 BACKSPACE( 11 )
-    READ( 11 , '(A)') line
-    CALL parin_fail_message( 'runtime_parameters', line )
-
- 16 REWIND( 11 )
-    line = ' '
-    DO WHILE ( INDEX( line, '&d3par' ) == 0 )
-       READ( 11, '(A)', END=18 )  line
-    ENDDO
-    BACKSPACE ( 11 )
-
-!
-!-- Read namelist
-    READ( 11, d3par, ERR = 17, END = 18 )
-
-    message_string = 'namelist d3par is deprecated and will be ' //                                &
-                     'removed in near future. &Please use namelist ' //                            &
-                     'runtime_parameters instead'
-    CALL message( 'parin', 'PA0487', 0, 1, 0, 6, 0 )
-
-    GOTO 18
-
- 17 BACKSPACE( 11 )
-    READ( 11 , '(A)') line
-    CALL parin_fail_message( 'd3par', line )
-
- 18 CONTINUE
+    READ( 11, runtime_parameters, IOSTAT=io_status )
+
+    IF ( io_status > 0 )  THEN
+!
+!--    Namelist runtime_parameters was found but contained errors. Print an error message including
+!--    the line that caused the problem.
+       BACKSPACE( 11 )
+       READ( 11 , '(A)') line
+       CALL parin_fail_message( 'runtime_parameters', line )
+
+    ENDIF
 
 !
Index: /palm/trunk/SOURCE/plant_canopy_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 4841)
+++ /palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 4842)
@@ -26,4 +26,9 @@
 ! -----------------
 ! $Id$
+! reading of namelist file and actions in case of namelist errors revised so that statement labels
+! and goto statements are not required any more,
+! deprecaed namelist name removed
+!
+! 4828 2021-01-05 11:21:41Z Giersch
 ! file re-formatted to follow the PALM coding standard
 !
@@ -1550,93 +1555,51 @@
 !> Parin for &plant_canopy_parameters for plant canopy model
 !--------------------------------------------------------------------------------------------------!
-    SUBROUTINE pcm_parin
-
-       CHARACTER (LEN=80) ::  line  !< dummy string that contains the current line of the parameter file
-
-       NAMELIST /plant_canopy_parameters/  alpha_lad,                                              &
-                                           beta_lad,                                               &
-                                           canopy_drag_coeff,                                      &
-                                           canopy_mode,                                            &
-                                           cthf,                                                   &
-                                           lad_surface,                                            &
-                                           lad_type_coef,                                          &
-                                           lad_vertical_gradient,                                  &
-                                           lad_vertical_gradient_level,                            &
-                                           lai_beta,                                               &
-                                           leaf_scalar_exch_coeff,                                 &
-                                           leaf_surface_conc,                                      &
-                                           pch_index,                                              &
-                                           plant_canopy_transpiration
-
-       NAMELIST /canopy_par/               alpha_lad,                                              &
-                                           beta_lad,                                               &
-                                           canopy_drag_coeff,                                      &
-                                           canopy_mode,                                            &
-                                           cthf,                                                   &
-                                           lad_surface,                                            &
-                                           lad_type_coef,                                          &
-                                           lad_vertical_gradient,                                  &
-                                           lad_vertical_gradient_level,                            &
-                                           lai_beta,                                               &
-                                           leaf_scalar_exch_coeff,                                 &
-                                           leaf_surface_conc,                                      &
-                                           pch_index,                                              &
-                                           plant_canopy_transpiration
-
-       line = ' '
-
-!
-!--    Try to find plant-canopy model package
-       REWIND( 11 )
-       line = ' '
-       DO WHILE ( INDEX( line, '&plant_canopy_parameters' ) == 0 )
-          READ( 11, '(A)', END=12 )  line
-       ENDDO
+ SUBROUTINE pcm_parin
+
+    CHARACTER(LEN=100) ::  line  !< dummy string that contains the current line of the parameter file
+
+    INTEGER(iwp) ::  io_status   !< status after reading the namelist file
+
+
+    NAMELIST /plant_canopy_parameters/  alpha_lad,                                                 &
+                                        beta_lad,                                                  &
+                                        canopy_drag_coeff,                                         &
+                                        canopy_mode,                                               &
+                                        cthf,                                                      &
+                                        lad_surface,                                               &
+                                        lad_type_coef,                                             &
+                                        lad_vertical_gradient,                                     &
+                                        lad_vertical_gradient_level,                               &
+                                        lai_beta,                                                  &
+                                        leaf_scalar_exch_coeff,                                    &
+                                        leaf_surface_conc,                                         &
+                                        pch_index,                                                 &
+                                        plant_canopy_transpiration
+
+!
+!-- Move to the beginning of the namelist file and try to find and read the user-defined namelist
+!-- plant_canopy_parameters.
+    REWIND( 11 )
+    READ( 11, plant_canopy_parameters, IOSTAT=io_status )
+
+!
+!-- Action depending on the READ status
+    IF ( io_status == 0 )  THEN
+!
+!--    plant_canopy_parameters namelist was found and read correctly. Set flag that indicates that
+!--    the plant-canopy model is switched on.
+       plant_canopy = .TRUE.
+
+    ELSEIF ( io_status > 0 )  THEN
+!
+!--    plant_canopy_parameters namelist was found but contained errors. Print an error message
+!--    including the line that caused the problem.
        BACKSPACE( 11 )
-
-!
-!--    Read user-defined namelist
-       READ( 11, plant_canopy_parameters, ERR = 10 )
-
-!
-!--    Set flag that indicates that the plant-canopy model is switched on
-       plant_canopy = .TRUE.
-
-       GOTO 14
-
- 10    BACKSPACE( 11 )
-       READ( 11 , '(A)') line
+       READ( 11 , '(A)' ) line
        CALL parin_fail_message( 'plant_canopy_parameters', line )
-!
-!--    Try to find old namelist
- 12    REWIND( 11 )
-       line = ' '
-       DO WHILE ( INDEX( line, '&canopy_par' ) == 0 )
-          READ( 11, '(A)', END=14 )  line
-       ENDDO
-       BACKSPACE( 11 )
-
-!
-!--    Read user-defined namelist
-       READ( 11, canopy_par, ERR = 13, END = 14 )
-
-       message_string = 'namelist canopy_par is deprecated and will be ' //                        &
-                        'removed in near future. Please use namelist ' //                          &
-                        'plant_canopy_parameters instead'
-       CALL message( 'pcm_parin', 'PA0487', 0, 1, 0, 6, 0 )
-
-!
-!--    Set flag that indicates that the plant-canopy model is switched on
-       plant_canopy = .TRUE.
-
-       GOTO 14
-
- 13    BACKSPACE( 11 )
-       READ( 11 , '(A)') line
-       CALL parin_fail_message( 'canopy_par', line )
-
- 14    CONTINUE
-
-    END SUBROUTINE pcm_parin
+
+    ENDIF
+
+ END SUBROUTINE pcm_parin
 
 
Index: /palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4841)
+++ /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4842)
@@ -27,5 +27,10 @@
 ! -----------------
 ! $Id$
-! openmp bugfix: some missing arrays added to reduction clause 
+! reading of namelist file and actions in case of namelist errors revised so that statement labels
+! and goto statements are not required any more,
+! deprectaed namelist name removed
+!
+! 4836 2021-01-07 13:58:12Z raasch
+! openmp bugfix: some missing arrays added to reduction clause
 !
 ! 4824 2020-12-12 20:45:23Z moh.hefny
@@ -717,34 +722,34 @@
                                    0.06_wp, 0.06_wp, 0.06_wp,            & !  1 - ocean
                                    0.19_wp, 0.28_wp, 0.09_wp,            & !  2 - mixed farming, tall grassland
-                                   0.23_wp, 0.33_wp, 0.11_wp,            & !  3 - tall/medium grassland 
-                                   0.23_wp, 0.33_wp, 0.11_wp,            & !  4 - evergreen shrubland 
-                                   0.25_wp, 0.34_wp, 0.14_wp,            & !  5 - short grassland/meadow/shrubland 
-                                   0.14_wp, 0.22_wp, 0.06_wp,            & !  6 - evergreen needleleaf forest 
-                                   0.17_wp, 0.27_wp, 0.06_wp,            & !  7 - mixed deciduous forest 
-                                   0.19_wp, 0.31_wp, 0.06_wp,            & !  8 - deciduous forest 
+                                   0.23_wp, 0.33_wp, 0.11_wp,            & !  3 - tall/medium grassland
+                                   0.23_wp, 0.33_wp, 0.11_wp,            & !  4 - evergreen shrubland
+                                   0.25_wp, 0.34_wp, 0.14_wp,            & !  5 - short grassland/meadow/shrubland
+                                   0.14_wp, 0.22_wp, 0.06_wp,            & !  6 - evergreen needleleaf forest
+                                   0.17_wp, 0.27_wp, 0.06_wp,            & !  7 - mixed deciduous forest
+                                   0.19_wp, 0.31_wp, 0.06_wp,            & !  8 - deciduous forest
                                    0.14_wp, 0.22_wp, 0.06_wp,            & !  9 - tropical evergreen broadleaved forest
-                                   0.18_wp, 0.28_wp, 0.06_wp,            & ! 10 - medium/tall grassland/woodland 
-                                   0.43_wp, 0.51_wp, 0.35_wp,            & ! 11 - desert, sandy 
-                                   0.32_wp, 0.40_wp, 0.24_wp,            & ! 12 - desert, rocky 
-                                   0.19_wp, 0.27_wp, 0.10_wp,            & ! 13 - tundra 
-                                   0.77_wp, 0.65_wp, 0.90_wp,            & ! 14 - land ice 
-                                   0.77_wp, 0.65_wp, 0.90_wp,            & ! 15 - sea ice 
-                                   0.82_wp, 0.70_wp, 0.95_wp,            & ! 16 - snow 
-                                   0.08_wp, 0.08_wp, 0.08_wp,            & ! 17 - bare soil 
-                                   0.17_wp, 0.17_wp, 0.17_wp,            & ! 18 - asphalt/concrete mix 
-                                   0.17_wp, 0.17_wp, 0.17_wp,            & ! 19 - asphalt (asphalt concrete) 
-                                   0.30_wp, 0.30_wp, 0.30_wp,            & ! 20 - concrete (Portland concrete) 
-                                   0.17_wp, 0.17_wp, 0.17_wp,            & ! 21 - sett 
+                                   0.18_wp, 0.28_wp, 0.06_wp,            & ! 10 - medium/tall grassland/woodland
+                                   0.43_wp, 0.51_wp, 0.35_wp,            & ! 11 - desert, sandy
+                                   0.32_wp, 0.40_wp, 0.24_wp,            & ! 12 - desert, rocky
+                                   0.19_wp, 0.27_wp, 0.10_wp,            & ! 13 - tundra
+                                   0.77_wp, 0.65_wp, 0.90_wp,            & ! 14 - land ice
+                                   0.77_wp, 0.65_wp, 0.90_wp,            & ! 15 - sea ice
+                                   0.82_wp, 0.70_wp, 0.95_wp,            & ! 16 - snow
+                                   0.08_wp, 0.08_wp, 0.08_wp,            & ! 17 - bare soil
+                                   0.17_wp, 0.17_wp, 0.17_wp,            & ! 18 - asphalt/concrete mix
+                                   0.17_wp, 0.17_wp, 0.17_wp,            & ! 19 - asphalt (asphalt concrete)
+                                   0.30_wp, 0.30_wp, 0.30_wp,            & ! 20 - concrete (Portland concrete)
+                                   0.17_wp, 0.17_wp, 0.17_wp,            & ! 21 - sett
                                    0.17_wp, 0.17_wp, 0.17_wp,            & ! 22 - paving stones
-                                   0.17_wp, 0.17_wp, 0.17_wp,            & ! 23 - cobblestone 
+                                   0.17_wp, 0.17_wp, 0.17_wp,            & ! 23 - cobblestone
                                    0.17_wp, 0.17_wp, 0.17_wp,            & ! 24 - metal
                                    0.17_wp, 0.17_wp, 0.17_wp,            & ! 25 - wood
                                    0.17_wp, 0.17_wp, 0.17_wp,            & ! 26 - gravel
-                                   0.17_wp, 0.17_wp, 0.17_wp,            & ! 27 - fine gravel 
-                                   0.17_wp, 0.17_wp, 0.17_wp,            & ! 28 - pebblestone 
+                                   0.17_wp, 0.17_wp, 0.17_wp,            & ! 27 - fine gravel
+                                   0.17_wp, 0.17_wp, 0.17_wp,            & ! 28 - pebblestone
                                    0.17_wp, 0.17_wp, 0.17_wp,            & ! 29 - woodchips
                                    0.17_wp, 0.17_wp, 0.17_wp,            & ! 30 - tartan (sports)
                                    0.17_wp, 0.17_wp, 0.17_wp,            & ! 31 - artificial turf (sports)
-                                   0.17_wp, 0.17_wp, 0.17_wp,            & ! 32 - clay (sports) 
+                                   0.17_wp, 0.17_wp, 0.17_wp,            & ! 32 - clay (sports)
                                    0.17_wp, 0.17_wp, 0.17_wp,            & ! 33 - building (dummy)
                                    0.60_wp, 0.60_wp, 0.60_wp,            & ! 34 - building wall type 1 - reflecting facade
@@ -4105,42 +4110,9 @@
  SUBROUTINE radiation_parin
 
-
     IMPLICIT NONE
 
-    CHARACTER(LEN=80) ::  line  !< dummy string that contains the current line of the parameter file
-
-    NAMELIST /radiation_par/   albedo,                                                             &
-                               albedo_lw_dif,                                                      &
-                               albedo_lw_dir,                                                      &
-                               albedo_sw_dif,                                                      &
-                               albedo_sw_dir,                                                      &
-                               albedo_type,                                                        &
-                               bufsize_alltoall,                                                   &
-                               constant_albedo,                                                    &
-                               dt_radiation,                                                       &
-                               emissivity,                                                         &
-                               lw_radiation,                                                       &
-                               max_raytracing_dist,                                                &
-                               min_irrf_value,                                                     &
-                               mrt_geom,                                                           &
-                               mrt_geom_params,                                                    &
-                               mrt_include_sw,                                                     &
-                               mrt_nlevels,                                                        &
-                               mrt_skip_roof,                                                      &
-                               net_radiation,                                                      &
-                               nrefsteps,                                                          &
-                               plant_lw_interact,                                                  &
-                               rad_angular_discretization,                                         &
-                               radiation_interactions_on,                                          &
-                               radiation_scheme,                                                   &
-                               raytrace_discrete_azims,                                            &
-                               raytrace_discrete_elevs,                                            &
-                               raytrace_mpi_rma,                                                   &
-                               trace_fluxes_above,                                                 &
-                               skip_time_do_radiation,                                             &
-                               surface_reflections,                                                &
-                               svfnorm_report_thresh,                                              &
-                               sw_radiation,                                                       &
-                               unscheduled_radiation_calls
+    CHARACTER(LEN=100) ::  line  !< dummy string that contains the current line of the parameter file
+
+    INTEGER(iwp) ::  io_status   !< status after reading the namelist file
 
 
@@ -4179,62 +4151,26 @@
                                     unscheduled_radiation_calls
 
-    line = ' '
-
-!
-!-- Try to find radiation model namelist
+!
+!-- Move to the beginning of the namelist file and try to find and read the namelist.
     REWIND( 11 )
-    line = ' '
-    DO WHILE ( INDEX( line, '&radiation_parameters' ) == 0 )
-       READ( 11, '(A)', END = 12 )  line
-    ENDDO
-    BACKSPACE( 11 )
-
-!
-!-- Read user-defined namelist
-    READ( 11, radiation_parameters, ERR = 10 )
-
-!
-!-- Set flag that indicates that the radiation model is switched on
-    radiation = .TRUE.
-
-    GOTO 14
-
- 10 BACKSPACE( 11 )
-    READ( 11 , '(A)') line
-    CALL parin_fail_message( 'radiation_parameters', line )
-!
-!-- Try to find old namelist
- 12 REWIND( 11 )
-    line = ' '
-    DO WHILE ( INDEX( line, '&radiation_par' ) == 0 )
-       READ( 11, '(A)', END = 14 )  line
-    ENDDO
-    BACKSPACE( 11 )
-
-!
-!-- Read user-defined namelist
-    READ( 11, radiation_par, ERR = 13, END = 14 )
-
-    message_string = 'namelist radiation_par is deprecated and will be removed in near future. '// &
-                     'Please use namelist radiation_parameters instead'
-    CALL message( 'radiation_parin', 'PA0487', 0, 1, 0, 6, 0 )
-
-!
-!-- Set flag that indicates that the radiation model is switched on
-    radiation = .TRUE.
-
-    IF ( .NOT.  radiation_interactions_on  .AND.  surface_reflections )  THEN
-       message_string = 'surface_reflections is allowed only when ' //                             &
-                        'radiation_interactions_on is set to TRUE'
-       CALL message( 'radiation_parin', 'PA0293',1, 2, 0, 6, 0 )
+    READ( 11, radiation_parameters, IOSTAT=io_status )
+
+!
+!-- Action depending on the READ status
+    IF ( io_status == 0 )  THEN
+!
+!--    radiation_parameters namelist was found and read correctly. Set flag that indicates that the
+!--    radiation model is switched on.
+       radiation = .TRUE.
+
+    ELSEIF ( io_status > 0 )  THEN
+!
+!--    radiation_parameters namelist was found but contained errors. Print an error message
+!--    including the line that caused the problem.
+       BACKSPACE( 11 )
+       READ( 11 , '(A)' ) line
+       CALL parin_fail_message( 'radiation_parameters', line )
+
     ENDIF
-
-    GOTO 14
-
- 13 BACKSPACE( 11 )
-    READ( 11 , '(A)') line
-    CALL parin_fail_message( 'radiation_par', line )
-
- 14 CONTINUE
 
  END SUBROUTINE radiation_parin
